# Redux

We are using **Redux** for our application state management. it maintains the state of the entire application in a single immutable state tree (object), which can't be changed directly. When something changes, a new object is created (using actions and reducers). For more information about Redux, visit The [official documentation][https://redux.js.org/].

## Store

The following are the existing store entities used by our application:

- `Global`: Preserves the global state, which includes `isPublic` and `screenType` (Mobile/Tablet/Desktop).  
- `UploadDocument`: Manages the state of uploaded documents. 
- `Profile`: Preserves the state of tutorials and notifications.



For each reducer file, a test file is associated testing the reducer.

All the actions are tested in a separate file with the same actions file name. 

## Used packages

- **react-redux**: Official React bindings for [Redux](https://github.com/reduxjs/redux).
- **redux-devtools-extension**: For debugging application's state changes.
- **@types/react-redux**: This package contains type definitions for react-redux.